require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&__ASM_HARDIRQ_H)) {
	eval 'sub __ASM_HARDIRQ_H () {1;}' unless defined(&__ASM_HARDIRQ_H);
	require 'linux/config.ph';
	require 'linux/brlock.ph';
	require 'linux/spinlock.ph';
	unless(defined(&CONFIG_SMP)) {
	} else {
	}
	require 'linux/irq_cpustat.ph';
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub irq_enter {
	        local($cpu) = @_;
    		eval q(( &local_irq_count($cpu)++));
	    }' unless defined(&irq_enter);
	    eval 'sub irq_exit {
	        local($cpu) = @_;
    		eval q(( &local_irq_count($cpu)--));
	    }' unless defined(&irq_exit);
	} else {
	    undef(&local_irq_count) if defined(&local_irq_count);
	    eval 'sub local_irq_count {
	        local($cpu) = @_;
    		eval q(( $__brlock_array[$cpu][ &BR_GLOBALIRQ_LOCK]));
	    }' unless defined(&local_irq_count);
	    eval 'sub irq_enter {
	        local($cpu) = @_;
    		eval q( &br_read_lock( &BR_GLOBALIRQ_LOCK));
	    }' unless defined(&irq_enter);
	    eval 'sub irq_exit {
	        local($cpu) = @_;
    		eval q( &br_read_unlock( &BR_GLOBALIRQ_LOCK));
	    }' unless defined(&irq_exit);
	}
	eval 'sub in_interrupt () {
	    eval q(({ \'int\'  &__cpu =  &smp_processor_id(); ( &local_irq_count( &__cpu) +  &local_bh_count( &__cpu) != 0); }));
	}' unless defined(&in_interrupt);
	eval 'sub in_irq () {
	    eval q(( &local_irq_count( &smp_processor_id()) != 0));
	}' unless defined(&in_irq);
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub hardirq_trylock {
	        local($cpu) = @_;
    		eval q(( &local_irq_count($cpu) == 0));
	    }' unless defined(&hardirq_trylock);
	    eval 'sub hardirq_endlock {
	        local($cpu) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&hardirq_endlock);
	    eval 'sub synchronize_irq () {
	        eval q( &barrier());
	    }' unless defined(&synchronize_irq);
	} else {
	    eval 'sub hardirq_endlock {
	        local($cpu) = @_;
    		eval q( &do { ($cpu); }  &while (0));
	    }' unless defined(&hardirq_endlock);
	}
    }
}
1;
