require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC64_HW_IRQ_H)) {
	eval 'sub _PPC64_HW_IRQ_H () {1;}' unless defined(&_PPC64_HW_IRQ_H);
	require 'linux/config.ph';
	require 'asm/irq.ph';
	if(defined(&CONFIG_PPC_ISERIES)) {
	    eval 'sub __cli () {
	        eval q( &__no_use_cli());
	    }' unless defined(&__cli);
	    eval 'sub __sti () {
	        eval q( &__no_use_sti());
	    }' unless defined(&__sti);
	    eval 'sub __save_flags {
	        local($flags) = @_;
    		eval q((($flags) =  &__no_use_save_flags()));
	    }' unless defined(&__save_flags);
	    eval 'sub __restore_flags {
	        local($flags) = @_;
    		eval q( &__no_use_restore_flags($flags));
	    }' unless defined(&__restore_flags);
	    eval 'sub __save_and_cli {
	        local($flags) = @_;
    		eval q(({ &__save_flags($flags); &__cli();}));
	    }' unless defined(&__save_and_cli);
	} else {
	    eval 'sub __save_flags {
	        local($flags) = @_;
    		eval q((($flags) =  &mfmsr()));
	    }' unless defined(&__save_flags);
	    eval 'sub __restore_flags {
	        local($flags) = @_;
    		eval q( &mtmsrd($flags));
	    }' unless defined(&__restore_flags);
	    eval 'sub __save_and_cli {
	        local($flags) = @_;
    		eval q( &__do_save_and_cli($flags));
	    }' unless defined(&__save_and_cli);
	}
	eval 'sub mask_irq {
	    local($irq) = @_;
    	    eval q(({ &if ( ($irq_desc[$irq]->{handler})  &&  ($irq_desc[$irq]->{handler}->{disable}))  ($irq_desc[$irq]->{handler}->{disable})($irq);}));
	}' unless defined(&mask_irq);
	eval 'sub unmask_irq {
	    local($irq) = @_;
    	    eval q(({ &if ( ($irq_desc[$irq]->{handler})  &&  ($irq_desc[$irq]->{handler}->{enable}))  ($irq_desc[$irq]->{handler}->{enable})($irq);}));
	}' unless defined(&unmask_irq);
	eval 'sub ack_irq {
	    local($irq) = @_;
    	    eval q(({ &if ( ($irq_desc[$irq]->{handler})  &&  ($irq_desc[$irq]->{handler}->{ack}))  ($irq_desc[$irq]->{handler}->{ack})($irq);}));
	}' unless defined(&ack_irq);
    }
}
1;
