require '_h2ph_pre.ph';

unless(defined(&_PPC64_IO_H)) {
    eval 'sub _PPC64_IO_H () {1;}' unless defined(&_PPC64_IO_H);
    require 'linux/config.ph';
    require 'asm/page.ph';
    require 'asm/byteorder.ph';
    if(defined(&CONFIG_PPC_ISERIES)) {
	require 'asm/iSeries/iSeries_io.ph';
    }
    require 'asm/memory.ph';
    require 'asm/delay.ph';
    eval 'sub SIO_CONFIG_RA () {0x398;}' unless defined(&SIO_CONFIG_RA);
    eval 'sub SIO_CONFIG_RD () {0x399;}' unless defined(&SIO_CONFIG_RD);
    eval 'sub SLOW_DOWN_IO () {1;}' unless defined(&SLOW_DOWN_IO);
    undef(&__IO_DEBUG) if defined(&__IO_DEBUG);
    eval 'sub _IO_BASE () { &isa_io_base;}' unless defined(&_IO_BASE);
    eval 'sub _ISA_MEM_BASE () { &isa_mem_base;}' unless defined(&_ISA_MEM_BASE);
    eval 'sub PCI_DRAM_OFFSET () { &pci_dram_offset;}' unless defined(&PCI_DRAM_OFFSET);
    if(defined(&CONFIG_PPC_ISERIES)) {
	eval 'sub readb {
	    local($addr) = @_;
    	    eval q( &iSeries_Read_Byte(($addr)));
	}' unless defined(&readb);
	eval 'sub readw {
	    local($addr) = @_;
    	    eval q( &iSeries_Read_Word(($addr)));
	}' unless defined(&readw);
	eval 'sub readl {
	    local($addr) = @_;
    	    eval q( &iSeries_Read_Long(($addr)));
	}' unless defined(&readl);
	eval 'sub writeb {
	    local($data, $addr) = @_;
    	    eval q( &iSeries_Write_Byte($data,(($addr))));
	}' unless defined(&writeb);
	eval 'sub writew {
	    local($data, $addr) = @_;
    	    eval q( &iSeries_Write_Word($data,(($addr))));
	}' unless defined(&writew);
	eval 'sub writel {
	    local($data, $addr) = @_;
    	    eval q( &iSeries_Write_Long($data,(($addr))));
	}' unless defined(&writel);
	eval 'sub memset_io {
	    local($a,$b,$c) = @_;
    	    eval q( &iSeries_memset(($a),($b),($c)));
	}' unless defined(&memset_io);
	eval 'sub memcpy_fromio {
	    local($a,$b,$c) = @_;
    	    eval q( &iSeries_memcpy_fromio(, ($b), ($c)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    local($a,$b,$c) = @_;
    	    eval q( &iSeries_memcpy_toio(, ($b), ($c)));
	}' unless defined(&memcpy_toio);
	eval 'sub inb {
	    local($addr) = @_;
    	    eval q( &readb((($addr))));
	}' unless defined(&inb);
	eval 'sub inw {
	    local($addr) = @_;
    	    eval q( &readw((($addr))));
	}' unless defined(&inw);
	eval 'sub inl {
	    local($addr) = @_;
    	    eval q( &readl((($addr))));
	}' unless defined(&inl);
	eval 'sub outb {
	    local($data,$addr) = @_;
    	    eval q( &writeb($data,(($addr))));
	}' unless defined(&outb);
	eval 'sub outw {
	    local($data,$addr) = @_;
    	    eval q( &writew($data,(($addr))));
	}' unless defined(&outw);
	eval 'sub outl {
	    local($data,$addr) = @_;
    	    eval q( &writel($data,(($addr))));
	}' unless defined(&outl);
    } else {
	eval 'sub IS_MAPPED_VADDR {
	    local($port) = @_;
    	    eval q((($port) >> 60));
	}' unless defined(&IS_MAPPED_VADDR);
	eval 'sub readb {
	    local($addr) = @_;
    	    eval q( &eeh_readb(($addr)));
	}' unless defined(&readb);
	eval 'sub readw {
	    local($addr) = @_;
    	    eval q( &eeh_readw(($addr)));
	}' unless defined(&readw);
	eval 'sub readl {
	    local($addr) = @_;
    	    eval q( &eeh_readl(($addr)));
	}' unless defined(&readl);
	eval 'sub writeb {
	    local($data, $addr) = @_;
    	    eval q( &eeh_writeb(, (($addr))));
	}' unless defined(&writeb);
	eval 'sub writew {
	    local($data, $addr) = @_;
    	    eval q( &eeh_writew(, (($addr))));
	}' unless defined(&writew);
	eval 'sub writel {
	    local($data, $addr) = @_;
    	    eval q( &eeh_writel(, (($addr))));
	}' unless defined(&writel);
	eval 'sub memset_io {
	    local($a,$b,$c) = @_;
    	    eval q( &eeh_memset(($a),($b),($c)));
	}' unless defined(&memset_io);
	eval 'sub memcpy_fromio {
	    local($a,$b,$c) = @_;
    	    eval q( &eeh_memcpy_fromio(,($b),($c)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    local($a,$b,$c) = @_;
    	    eval q( &eeh_memcpy_toio(($a),($b),($c)));
	}' unless defined(&memcpy_toio);
	eval 'sub inb {
	    local($port) = @_;
    	    eval q( &_inb($port));
	}' unless defined(&inb);
	eval 'sub outb {
	    local($val, $port) = @_;
    	    eval q( &_outb($val, $port));
	}' unless defined(&outb);
	eval 'sub inw {
	    local($port) = @_;
    	    eval q( &_inw($port));
	}' unless defined(&inw);
	eval 'sub outw {
	    local($val, $port) = @_;
    	    eval q( &_outw($val, $port));
	}' unless defined(&outw);
	eval 'sub inl {
	    local($port) = @_;
    	    eval q( &_inl($port));
	}' unless defined(&inl);
	eval 'sub outl {
	    local($val, $port) = @_;
    	    eval q( &_outl($val, $port));
	}' unless defined(&outl);
    }
    eval 'sub inb_p {
        local($port) = @_;
	    eval q( &inb($port));
    }' unless defined(&inb_p);
    eval 'sub outb_p {
        local($val, $port) = @_;
	    eval q(( &udelay(1),  &outb(($val), ($port))));
    }' unless defined(&outb_p);
    eval 'sub inw_p {
        local($port) = @_;
	    eval q( &inw($port));
    }' unless defined(&inw_p);
    eval 'sub outw_p {
        local($val, $port) = @_;
	    eval q(( &udelay(1),  &outw(($val), ($port))));
    }' unless defined(&outw_p);
    eval 'sub inl_p {
        local($port) = @_;
	    eval q( &inl($port));
    }' unless defined(&inl_p);
    eval 'sub outl_p {
        local($val, $port) = @_;
	    eval q(( &udelay(1),  &outl(($val, ($port))));
    }' unless defined(&outl_p);
    eval 'sub _IOMAP_VADDR {
        local($port) = @_;
	    eval q(( &IS_MAPPED_VADDR($port) ? ($port) : ($port)+ &_IO_BASE));
    }' unless defined(&_IOMAP_VADDR);
    eval 'sub insb {
        local($port, $buf, $ns) = @_;
	    eval q( &_insb(( &_IOMAP_VADDR($port)), ($buf), ($ns)));
    }' unless defined(&insb);
    eval 'sub outsb {
        local($port, $buf, $ns) = @_;
	    eval q( &_outsb(( &_IOMAP_VADDR($port)), ($buf), ($ns)));
    }' unless defined(&outsb);
    eval 'sub insw {
        local($port, $buf, $ns) = @_;
	    eval q( &_insw_ns(( &_IOMAP_VADDR($port)), ($buf), ($ns)));
    }' unless defined(&insw);
    eval 'sub outsw {
        local($port, $buf, $ns) = @_;
	    eval q( &_outsw_ns(( &_IOMAP_VADDR($port)), ($buf), ($ns)));
    }' unless defined(&outsw);
    eval 'sub insl {
        local($port, $buf, $nl) = @_;
	    eval q( &_insl_ns(( &_IOMAP_VADDR($port)), ($buf), ($nl)));
    }' unless defined(&insl);
    eval 'sub outsl {
        local($port, $buf, $nl) = @_;
	    eval q( &_outsl_ns(( &_IOMAP_VADDR($port)), ($buf), ($nl)));
    }' unless defined(&outsl);
    eval 'sub insw_ns {
        local($port, $buf, $ns) = @_;
	    eval q( &_insw_ns(( &_IOMAP_VADDR($port)), ($buf), ($ns)));
    }' unless defined(&insw_ns);
    eval 'sub outsw_ns {
        local($port, $buf, $ns) = @_;
	    eval q( &_outsw_ns(( &_IOMAP_VADDR($port)), ($buf), ($ns)));
    }' unless defined(&outsw_ns);
    eval 'sub insl_ns {
        local($port, $buf, $nl) = @_;
	    eval q( &_insl_ns(( &_IOMAP_VADDR($port)), ($buf), ($nl)));
    }' unless defined(&insl_ns);
    eval 'sub outsl_ns {
        local($port, $buf, $nl) = @_;
	    eval q( &_outsl_ns(( &_IOMAP_VADDR($port)), ($buf), ($nl)));
    }' unless defined(&outsl_ns);
    eval 'sub IO_SPACE_LIMIT () {~(0);}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub MEM_SPACE_LIMIT () {~(0);}' unless defined(&MEM_SPACE_LIMIT);
    if(defined(&__KERNEL__)) {
	eval 'sub ioremap_nocache {
	    local($addr, $size) = @_;
    	    eval q( &ioremap(($addr), ($size)));
	}' unless defined(&ioremap_nocache);
	if(defined(&__IO_DEBUG)) {
	}
	if(defined(&__IO_DEBUG)) {
	}
    }
    eval 'sub iobarrier_rw () {
        eval q( &eieio());
    }' unless defined(&iobarrier_rw);
    eval 'sub iobarrier_r () {
        eval q( &eieio());
    }' unless defined(&iobarrier_r);
    eval 'sub iobarrier_w () {
        eval q( &eieio());
    }' unless defined(&iobarrier_w);
    unless(defined(&CONFIG_PPC_ISERIES)) {
	require 'asm/eeh.ph';
    }
    if(defined(&__KERNEL__)) {
	unless(defined(&CONFIG_PPC_ISERIES)) {
	}
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
