require '_h2ph_pre.ph';

unless(defined(&_PPC64_PAGE_H)) {
    eval 'sub _PPC64_PAGE_H () {1;}' unless defined(&_PPC64_PAGE_H);
    require 'linux/config.ph';
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    eval 'sub PAGE_OFFSET_MASK () {( &PAGE_SIZE-1);}' unless defined(&PAGE_OFFSET_MASK);
    eval 'sub SID_SHIFT () {28;}' unless defined(&SID_SHIFT);
    eval 'sub SID_MASK () {0xfffffffff;}' unless defined(&SID_MASK);
    eval 'sub GET_ESID {
        local($x) = @_;
	    eval q(((($x) >>  &SID_SHIFT) &  &SID_MASK));
    }' unless defined(&GET_ESID);
    eval 'sub BUG_OPCODE () {.\'long 0x00b00b00\';}' unless defined(&BUG_OPCODE);
    eval 'sub BUG_ILLEGAL_INSTR () {"0x00b00b00";}' unless defined(&BUG_ILLEGAL_INSTR);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/Naca.ph';
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    eval 'sub REGION_SIZE () {4;}' unless defined(&REGION_SIZE);
	    eval 'sub OFFSET_SIZE () {60;}' unless defined(&OFFSET_SIZE);
	    eval 'sub REGION_SHIFT () {60;}' unless defined(&REGION_SHIFT);
	    eval 'sub OFFSET_SHIFT () {0;}' unless defined(&OFFSET_SHIFT);
	    eval 'sub REGION_MASK () {(((1<< &REGION_SIZE)-1)<< &REGION_SHIFT);}' unless defined(&REGION_MASK);
	    eval 'sub REGION_STRIDE () {(1 <<  &REGION_SHIFT);}' unless defined(&REGION_STRIDE);
	    eval 'sub __HAVE_ARCH_USER_PAGE () {1;}' unless defined(&__HAVE_ARCH_USER_PAGE);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    local($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
	    } else {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
	    }
	    if(defined(&CONFIG_XMON)) {
		require 'asm/ptrace.ph';
		eval 'sub BUG () {
		    eval q( &do {  &printk(\\"kernel BUG at %s:%d!\\\\n\\",  &__FILE__,  &__LINE__);  &xmon(0); }  &while (0));
		}' unless defined(&BUG);
	    } else {
		eval 'sub BUG () {
		    eval q( &do {  &printk(\\"kernel BUG at %s:%d!\\\\n\\",  &__FILE__,  &__LINE__);  &__asm__  &__volatile__(\\".long \\"  &BUG_ILLEGAL_INSTR); }  &while (0));
		}' unless defined(&BUG);
	    }
	    eval 'sub PAGE_BUG {
	        local($page) = @_;
    		eval q( &do {  &BUG(); }  &while (0));
	    }' unless defined(&PAGE_BUG);
	    eval 'sub __pa {
	        local($x) = @_;
    		eval q((($x)- &PAGE_OFFSET));
	    }' unless defined(&__pa);
	}
	eval 'sub _ALIGN_UP {
	    local($addr,$size) = @_;
    	    eval q(((($addr)+(($size)-1))(~(($size)-1))));
	}' unless defined(&_ALIGN_UP);
	eval 'sub _ALIGN_DOWN {
	    local($addr,$size) = @_;
    	    eval q((($addr)(~(($size)-1))));
	}' unless defined(&_ALIGN_DOWN);
	eval 'sub _ALIGN {
	    local($addr,$size) = @_;
    	    eval q( &_ALIGN_UP($addr,$size));
	}' unless defined(&_ALIGN);
	eval 'sub DOUBLEWORD_ALIGN {
	    local($addr) = @_;
    	    eval q( &_ALIGN($addr,$sizeof{\'unsigned long\'}));
	}' unless defined(&DOUBLEWORD_ALIGN);
	eval 'sub PAGE_ALIGN {
	    local($addr) = @_;
    	    eval q( &_ALIGN($addr,  &PAGE_SIZE));
	}' unless defined(&PAGE_ALIGN);
	if(defined(&MODULE)) {
	    eval 'sub __page_aligned () { &__attribute__(( &__aligned__( &PAGE_SIZE)));}' unless defined(&__page_aligned);
	} else {
	    eval 'sub __page_aligned () { &__attribute__(( &__aligned__( &PAGE_SIZE),  &__section__(".data.page_aligned")));}' unless defined(&__page_aligned);
	}
	eval 'sub PAGE_OFFSET () {0xc000000000000000;}' unless defined(&PAGE_OFFSET);
	eval 'sub KERNELBASE () { &PAGE_OFFSET;}' unless defined(&KERNELBASE);
	eval 'sub VMALLOCBASE () {0xd000000000000000;}' unless defined(&VMALLOCBASE);
	eval 'sub IOREGIONBASE () {0xe000000000000000;}' unless defined(&IOREGIONBASE);
	eval 'sub IO_REGION_ID () {( &IOREGIONBASE>> &REGION_SHIFT);}' unless defined(&IO_REGION_ID);
	eval 'sub VMALLOC_REGION_ID () {( &VMALLOCBASE>> &REGION_SHIFT);}' unless defined(&VMALLOC_REGION_ID);
	eval 'sub KERNEL_REGION_ID () {( &KERNELBASE>> &REGION_SHIFT);}' unless defined(&KERNEL_REGION_ID);
	eval 'sub USER_REGION_ID () {(0);}' unless defined(&USER_REGION_ID);
	eval 'sub REGION_ID {
	    local($X) = @_;
    	    eval q(((($X))>> &REGION_SHIFT));
	}' unless defined(&REGION_ID);
	eval 'sub VALID_EA_BITS () {(0x000001ffffffffff);}' unless defined(&VALID_EA_BITS);
	eval 'sub INVALID_EA_BITS () {(~( &REGION_MASK| &VALID_EA_BITS));}' unless defined(&INVALID_EA_BITS);
	eval 'sub IS_VALID_REGION_ID {
	    local($x) = @_;
    	    eval q(((($x) ==  &USER_REGION_ID) || (($x) >=  &KERNEL_REGION_ID)));
	}' unless defined(&IS_VALID_REGION_ID);
	eval 'sub IS_VALID_EA {
	    local($x) = @_;
    	    eval q(((!(($x) &  &INVALID_EA_BITS))  &&  &IS_VALID_REGION_ID( &REGION_ID($x))));
	}' unless defined(&IS_VALID_EA);
	eval 'sub __bpn_to_ba {
	    local($x) = @_;
    	    eval q((((($x))<< &PAGE_SHIFT) +  &KERNELBASE));
	}' unless defined(&__bpn_to_ba);
	eval 'sub __ba_to_bpn {
	    local($x) = @_;
    	    eval q((((($x)) & ~ &REGION_MASK) >>  &PAGE_SHIFT));
	}' unless defined(&__ba_to_bpn);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q(((($x) +  &KERNELBASE)));
	}' unless defined(&__va);
	eval 'sub __v2p {
	    local($x) = @_;
    	    eval q((  &__pa($x)));
	}' unless defined(&__v2p);
	eval 'sub __v2a {
	    local($x) = @_;
    	    eval q((  &phys_to_absolute( &__pa($x))));
	}' unless defined(&__v2a);
	eval 'sub __p2a {
	    local($x) = @_;
    	    eval q((  &phys_to_absolute($x)));
	}' unless defined(&__p2a);
	eval 'sub __p2v {
	    local($x) = @_;
    	    eval q((  &__va($x)));
	}' unless defined(&__p2v);
	eval 'sub __a2p {
	    local($x) = @_;
    	    eval q((  &absolute_to_phys($x)));
	}' unless defined(&__a2p);
	eval 'sub __a2v {
	    local($x) = @_;
    	    eval q((  &__va( &absolute_to_phys($x))));
	}' unless defined(&__a2v);
	eval 'sub virt_to_page {
	    local($kaddr) = @_;
    	    eval q(( &mem_map+( &__pa($kaddr) >>  &PAGE_SHIFT)));
	}' unless defined(&virt_to_page);
	eval 'sub VALID_PAGE {
	    local($page) = @_;
    	    eval q((($page -  &mem_map) <  &max_mapnr));
	}' unless defined(&VALID_PAGE);
	eval 'sub MAP_NR {
	    local($addr) = @_;
    	    eval q(( &__pa($addr) >>  &PAGE_SHIFT));
	}' unless defined(&MAP_NR);
    }
}
1;
