require '_h2ph_pre.ph';

unless(defined(&__PPC64_SYSTEM_H)) {
    eval 'sub __PPC64_SYSTEM_H () {1;}' unless defined(&__PPC64_SYSTEM_H);
    require 'linux/config.ph';
    require 'linux/kdev_t.ph';
    require 'asm/page.ph';
    require 'asm/processor.ph';
    require 'asm/hw_irq.ph';
    require 'asm/memory.ph';
    eval 'sub KERNEL_START_PHYS () {0x800000;}' unless defined(&KERNEL_START_PHYS);
    eval 'sub KERNEL_START () {( &PAGE_OFFSET+ &KERNEL_START_PHYS);}' unless defined(&KERNEL_START);
    eval 'sub START_ADDR () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x00000);}' unless defined(&START_ADDR);
    eval 'sub mb () {
        eval q( &__asm__  &__volatile__ (\\"sync\\" : : : \\"memory\\"));
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &__asm__  &__volatile__ (\\"lwsync\\" : : : \\"memory\\"));
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q( &__asm__  &__volatile__ (\\"eieio\\" : : : \\"memory\\"));
    }' unless defined(&wmb);
    eval 'sub set_mb {
        local($var, $value) = @_;
	    eval q( &do { $var = $value;  &mb(); }  &while (0));
    }' unless defined(&set_mb);
    eval 'sub set_wmb {
        local($var, $value) = @_;
	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
    }' unless defined(&set_wmb);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &rmb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &wmb());
	}' unless defined(&smp_wmb);
    } else {
	eval 'sub smp_mb () {
	    eval q( &__asm__  &__volatile__(\\"\\": : :\\"memory\\"));
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &__asm__  &__volatile__(\\"\\": : :\\"memory\\"));
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &__asm__  &__volatile__(\\"\\": : :\\"memory\\"));
	}' unless defined(&smp_wmb);
    }
    if(defined(&CONFIG_XMON)) {
    }
    eval 'sub prepare_to_switch () {
        eval q( &do { }  &while(0));
    }' unless defined(&prepare_to_switch);
    eval 'sub switch_to {
        local($prev,$next,$last) = @_;
	    eval q( &_switch_to(($prev),($next),($last)));
    }' unless defined(&switch_to);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub cli () {
	    eval q( &__cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    local($flags) = @_;
    	    eval q( &__save_flags($flags));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    local($flags) = @_;
    	    eval q( &__restore_flags($flags));
	}' unless defined(&restore_flags);
	eval 'sub save_and_cli {
	    local($flags) = @_;
    	    eval q( &__save_and_cli($flags));
	}' unless defined(&save_and_cli);
    } else {
	eval 'sub cli () {
	    eval q( &__global_cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__global_sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    local($x) = @_;
    	    eval q((($x)= &__global_save_flags()));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    local($x) = @_;
    	    eval q( &__global_restore_flags($x));
	}' unless defined(&restore_flags);
    }
    eval 'sub local_irq_disable () {
        eval q( &__cli());
    }' unless defined(&local_irq_disable);
    eval 'sub local_irq_enable () {
        eval q( &__sti());
    }' unless defined(&local_irq_enable);
    eval 'sub local_irq_save {
        local($flags) = @_;
	    eval q( &__save_and_cli($flags));
    }' unless defined(&local_irq_save);
    eval 'sub local_irq_restore {
        local($flags) = @_;
	    eval q( &__restore_flags($flags));
    }' unless defined(&local_irq_restore);
    eval 'sub xchg {
        local($ptr,$x) = @_;
	    eval q(({  &__typeof__(*)  &_x_ = ; ( &__typeof__(*))  &__xchg(,  &_x_, $sizeof{($ptr)}); }));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
    eval 'sub cmpxchg {
        local($ptr,$o,$n) = @_;
	    eval q(({  &__typeof__(*)  &_o_ = ;  &__typeof__(*)  &_n_ = ; ( &__typeof__(*))  &__cmpxchg(,  &_o_,  &_n_, $sizeof{($ptr)}); }));
    }' unless defined(&cmpxchg);
}
1;
